#!/bin/bash

# Borg repo location
REPOSITORY=/var/backup/files.borg/
# Example of remote repo
# REPOSITORY=ssh://backuper@192.168.1.100/var/backup/files.borg/

echo "`date +[%F/%T]` Starting the backup"
# Create backup
borg create -v --compression lzma,6 --stats $REPOSITORY::$(date +%Y-%m-%d-%H:%M) /etc/ /var/www/ /var/spool/ --exclude=*.log
# Clean old backups
borg prune -v $REPOSITORY --keep-daily=3 --keep-weekly=2 --keep-monthly=12
echo "`date +[%F/%T]` Done!"

exit
